/* cmdqbf_protos.h
 * prototypes for cmdqbf.c
 */
#ifndef CMDQBFPROTOSH
#define CMDQBFPROTOSH
#include "depqbf/qdpll.h"

static void cmdqbf_init(int, char **);
static void cmdqbf_initstrucs(void);
static void cmdqbf_commandline(int, char **);
static void cmdqbf_initfiles(void);
static void master_sendform(int);
static void worker_recvform(void);
static int cmdqbf_master(void);
static int cmdqbf_worker(void);
static void master_cleanup(MPI_Request *, int *, int *);

void add_to_joblist(VNode *);
void remove_jlist(VNode *);
void freenode(VNode *);

/* parser.c */
void cmdqbf_getinput(void);
void print_formula(void);
/* tree.c */
void master_inittree(void);
void simplify_tree(VNode *);
VNode *split_tree(VNode *, int);
void free_rem_tree(VNode *); /* to move */
void master_inittree(void);
/* util.c */
void parser_to_depqbf(QDPLL *);
void parser_to_sat(minisat_solver *);
void allocvars(QDPLL *, minisat_solver *, int);
void cmdqbf_add_qblock(QDPLL *, minisat_solver *, long *, char, int);
void cmdqbf_add_clause(QDPLL *, minisat_solver *, long *, int);
void reset_solver(void);
void set_budget(int, const long, const float);
void set_assumptions(const long *, const int);
int run_solver(void);

/*#ifdef HORDEQBF_DEPQBF*/
/* horde-mpi.c */
void mpi_hordeworker_init(void);
void master_interrupt(int);
int master_rand_interrupt(void);
/*#endif*/

#endif /* CMDQBFPROTOSH */
