#include "depqbf/qdpll.h"
#include <stdio.h>
#include <stdlib.h>

/*
p cnf 2 2
a 1 0
e 2 0
1 -2 0
-1 2 0

solve w/ assumptions: 1 -2
*/

int main(void)
{
	QDPLL *solver = qdpll_create();
	QDPLLResult res;
	int i, *ra;

	qdpll_new_scope(solver, QDPLL_QTYPE_FORALL);
	qdpll_add(solver, 1); qdpll_add(solver, 0);

	qdpll_new_scope(solver, QDPLL_QTYPE_EXISTS);
	qdpll_add(solver, 2); qdpll_add(solver, 0);

	qdpll_add(solver, 1); qdpll_add(solver, -2); qdpll_add(solver, 0);
	qdpll_add(solver, -1); qdpll_add(solver, 2); qdpll_add(solver, 0);

	qdpll_print(solver, stdout);

	printf("\nAssuming: 1 -2\n");
	qdpll_assume(solver, 1); qdpll_assume(solver, -2);

	res = qdpll_sat(solver);
	if (res == QDPLL_RESULT_SAT)
		printf("Result: SAT\n");
	else if (res == QDPLL_RESULT_UNSAT)
		printf("Result: UNSAT\n");

	ra = qdpll_get_relevant_assumptions(solver);

	printf("Relevant assumptions: ");
	for (i=0; ra[i]; i++)
		printf("%d ",ra[i]);
	printf("\n");

	free(ra);
	qdpll_delete(solver);
	return 0;
}
